'Placed in the Public Domain 5/24/97  John E. Carter
'johnecarter@mindspring.com
'converts tokenized Apple ][ Basic file to ascii
'
'requires PowerBasic 2.1 or higher to compile
'
'Apple ][ de-tokenizer - version 1.0 - 12/01/92
'Copyright 1992 John E. Carter
'Written for the PowerBASIC Compiler - if you program in BASIC under MS-DOS,
'you should be using PB.
defint a-z
dim tok$(128:255)
tok$(128)=" END "               'array of tokens
tok$(129)=" FOR "
tok$(130)=" NEXT "
tok$(131)=" DATA "
tok$(132)=" INPUT "
tok$(133)=" DEL "
tok$(134)=" DIM "
tok$(135)=" READ "
tok$(136)=" GR "
tok$(137)=" TEXT "
tok$(138)=" PR#"
tok$(139)=" IN# "
tok$(140)=" CALL "
tok$(141)=" PLOT "
tok$(142)=" HLIN "
tok$(143)=" VLIN "
tok$(144)=" HGR2 "
tok$(145)=" HGR "
tok$(146)=" HCOLOR= "
tok$(147)=" HPLOT "
tok$(148)=" DRAW "
tok$(149)=" XDRAW "
tok$(150)=" HTAB "
tok$(151)=" HOME "
tok$(152)=" ROT= "
tok$(153)=" SCALE= "
tok$(154)=" SHLOAD "
tok$(155)=" TRACE "
tok$(156)=" NOTRACE "
tok$(157)=" NORMAL "
tok$(158)=" INVERSE "
tok$(159)=" FLASH "
tok$(160)=" COLOR= "
tok$(161)=" POP "
tok$(162)=" VTAB "
tok$(163)=" HIMEM: "
tok$(164)=" LOMEM: "
tok$(165)=" ONERR "
tok$(166)=" RESUME "
tok$(167)=" RECALL "
tok$(168)=" STORE "
tok$(169)=" SPEED= "
tok$(170)=" LET "
tok$(171)=" GOTO "
tok$(172)=" RUN "
tok$(173)=" IF "
tok$(174)=" RESTORE "
tok$(175)=" & "
tok$(176)=" GOSUB "
tok$(177)=" RETURN "
tok$(178)=" REM "
tok$(179)=" STOP "
tok$(180)=" ON "
tok$(181)=" WAIT "
tok$(182)=" LOAD "
tok$(183)=" SAVE "
tok$(184)=" DEF "
tok$(185)=" POKE "
tok$(186)=" PRINT "
tok$(187)=" CONT "
tok$(188)=" LIST "
tok$(189)=" CLEAR "
tok$(190)=" GET "
tok$(191)=" NEW "
tok$(192)=" TAB("
tok$(193)=" TO "
tok$(194)=" FN "
tok$(195)=" SPC( "
tok$(196)=" THEN "
tok$(197)=" AT "
tok$(198)=" NOT "
tok$(199)=" STEP "
tok$(200)=" + "
tok$(201)=" - "
tok$(202)=" * "
tok$(203)=" / "
tok$(204)=" ^ "
tok$(205)=" AND "
tok$(206)=" OR "
tok$(207)=" > "
tok$(208)=" = "
tok$(209)=" < "
tok$(210)=" SGN "
tok$(211)=" INT "
tok$(212)=" ABS "
tok$(213)=" USR "
tok$(214)=" FRE "
tok$(215)=" SCRN( "
tok$(216)=" PDL "
tok$(217)=" POS "
tok$(218)=" SQR "
tok$(219)=" RND "
tok$(220)=" LOG "
tok$(221)=" EXP "
tok$(222)=" COS "
tok$(223)=" SIN "
tok$(224)=" TAN "
tok$(225)=" ATN "
tok$(226)=" PEEK"
tok$(227)=" LEN "
tok$(228)=" STR$ "
tok$(229)=" VAL"
tok$(230)=" ASC"
tok$(231)=" CHR$ "
tok$(232)=" LEFT$"
tok$(233)=" RIGHT$"
tok$(234)=" MID$"
' uXXX is an unused token value
tok$(235)=" u235 "
tok$(236)=" u236 "
tok$(237)=" u237 "
tok$(238)=" u238 "
tok$(239)=" u239 "
tok$(240)=" u240 "
tok$(241)=" u241 "
tok$(242)=" u242 "
tok$(243)=" u243 "
tok$(244)=" u244 "
tok$(245)=" u245 "
tok$(246)=" u246 "
tok$(247)=" u247 "
tok$(248)=" u248 "
tok$(249)=" u249 "
tok$(250)=" u250 "
tok$(251)=" u251 "
tok$(252)=" u252 "
tok$(253)=" u253 "
tok$(254)=" u254 "
tok$(255)=" u255 "

cls
x$ = "APPLE ][ BASIC De-tokenizer - Version 1.0"
call center(x$,80)
print x$
x$ = "Copyright 1992 John E. Carter"
call center(x$,80)
print x$

if command$ <> "" then         'if there are command line arguments
  cmd$ = command$
  inf$ = cmd$                  'assume it's a file name
  else
    print
    input "APPLE ][ BASIC file to translate: ";inf$
    if inf$ = "" then end
end if

dotloc = instr(inf$,".")          'does the file have an extension?
if dotloc > 0 then
  otf$ = left$(inf$, dotloc -1)   'chop it off to create output file name
  otf$ = otf$ + ".axl"            'add output file extension
else
  otf$ = inf$ + ".axl"            'or just add the extension
end if

k$ = dir$(inf$)                   'check for file
if len(k$) = 0 then               'if not there
  print inf$;" not found"
  end                             'quit
end if

open inf$ for binary as 1         'read it in binary mode
open otf$ for output as 2         'print in ASCII

get$ 1,32750,q$        'not likely to have a tokenized program larger than this
'Can your BASIC process a 32,750 character string?

t = 999                           'dummy value
k = 1                             'first position in string

lq = len(q$)                      'get the actual file size

print "Processing ";lq;" bytes from ";inf$;" to ";otf$

'this is the loop that extracts each line's data
while k <= lq                     'as long as we have bytes left
  x$ = ""
  addr! = ascii(mid$(q$,k,1))           'lo byte of address of next line
  incr k
  incr addr!, ascii(mid$(q$,k,1))*256   'hi byte of address of next line
  incr k
  linum! = ascii(mid$(q$,k,1))          'lo byte of line number
  incr k
  incr linum!, ascii(mid$(q$,k,1)) * 256  'hi byte of line number
  incr k
  t$ = mid$(q$,k,1)
  t = ascii(t$)
  while t <> 0                          'line ends with a null
    t$ = mid$(q$,k,1)                   'get one byte
    t = ascii(t$)
    if t > 30 and t < 128 then x$ = x$ + t$   'if printable, add to string
    if t > 127 then x$ = x$ + tok$(t)         'if token, add token text to string
    incr k
    if k > lq then exit loop                  'if done
  wend
  'end of extract loop
  x$ = str$(linum!,5) + " " + x$
  if csrlin > 22 then
    cls
    print "Processing ";lq;" bytes from ";inf$;" to ";otf$
  end if
  print x$                                   'display to screen
  print #2, x$                               'add to output file
wend
close
beep
print:print "DONE"
end

SUB center(x$,ll)
  xl = len(x$)
  pl = (ll -xl)/2
  x$ = space$(pl) + x$
END SUB
